package com.company.tldraw.screen.ui.components.javascript.googlemaps

import com.company.tldraw.screen.ui.components.javascript.googlemaps.state.GoogleMapState
import io.jmix.core.Messages
import io.jmix.core.security.CurrentAuthentication
//import io.jmix.sampler.SamplerProperties
import io.jmix.ui.component.Button
import io.jmix.ui.component.Form
import io.jmix.ui.component.JavaScriptComponent
import io.jmix.ui.component.JavaScriptComponent.JavaScriptCallbackEvent
import io.jmix.ui.component.TextField
import io.jmix.ui.screen.*
import org.springframework.beans.factory.annotation.Autowired

@UiController("java-script-component-google-maps")
@UiDescriptor("java-script-component-google-maps.xml")
class JavaScriptComponentGoogleMapsSample : Screen() {
    @Autowired
    protected var map: JavaScriptComponent? = null

    @Autowired
    private val markerForm: Form? = null

    @Autowired
    private val markerTitleField: TextField<String>? = null

    @Autowired
    private val markerLngField: TextField<Double>? = null

    @Autowired
    private val markerLatField: TextField<Double>? = null

    @Autowired
    private val screenValidation: ScreenValidation? = null

    @Autowired
    private val messages: Messages? = null

//    @Autowired
//    private val samplerProperties: SamplerProperties? = null

    @Autowired
    private val currentAuthentication: CurrentAuthentication? = null

    @Subscribe
    fun onAfterInit(event: AfterInitEvent?) {
        val state: GoogleMapState = GoogleMapState()
        state.lat = 53.590905
        state.lng = -2.24955
        state.zoom = 8
//        state.key = samplerProperties.getGoogleApiKey()
        state.language = currentAuthentication!!.locale.language
        map!!.state = state

        markerTitleField!!.setValue(messages!!.getMessage(JavaScriptComponentGoogleMapsSample::class.java, "marker"))
        markerLatField!!.setValue(state.lat)
        markerLngField!!.setValue(state.lng)

        // Define a function that can be called from client-side
        map!!.addFunction("onClick") { callBackEvent: JavaScriptCallbackEvent ->
            val array = callBackEvent.arguments
            markerLatField.setValue(array.getNumber(0))
            markerLngField.setValue(array.getNumber(1))
        }
    }

    @Subscribe("addMarkerBtn")
    fun onAddMarkerBtnClick(event: Button.ClickEvent?) {
        if (screenValidation!!.validateUiComponents(markerForm).isEmpty) {
            // Call a client-side function
            map!!.callFunction("addMarker", markerLatField!!.value, markerLngField!!.value, markerTitleField!!.value)
        }
    }
}