package com.company.tldraw.screen.ui.components.javascript.timepicker

import com.company.tldraw.screen.ui.components.javascript.timepicker.state.TimePickerState
import io.jmix.ui.Notifications
import io.jmix.ui.component.Button
import io.jmix.ui.component.JavaScriptComponent
import io.jmix.ui.component.JavaScriptComponent.JavaScriptCallbackEvent
import io.jmix.ui.screen.Screen
import io.jmix.ui.screen.ScreenFragment
import io.jmix.ui.screen.Subscribe
import io.jmix.ui.screen.UiController
import io.jmix.ui.screen.UiDescriptor
import org.springframework.beans.factory.annotation.Autowired

@UiController("java-script-component-time-picker")
@UiDescriptor("java-script-component-time-picker.xml")
class JavaScriptComponentTimePickerSample : Screen() {
    @Autowired
    protected var timePicker: JavaScriptComponent? = null

    @Autowired
    protected var notifications: Notifications? = null

    @Subscribe
    protected fun onInit(event: InitEvent?) {
        val state: TimePickerState = TimePickerState()
        state.now = "12:35:57"
        state.showSeconds = true
        state.twentyFour = true

        timePicker!!.addFunction(
            "onBeforeShow"
        ) { callbackEvent: JavaScriptCallbackEvent? ->
            notifications!!.create()
                .withCaption("Before Show Event")
                .withPosition(Notifications.Position.MIDDLE_RIGHT)
                .show()
        }

        timePicker!!.addFunction(
            "onShow"
        ) { callbackEvent: JavaScriptCallbackEvent? ->
            notifications!!.create()
                .withCaption("Show Event")
                .show()
        }

        timePicker!!.state = state
    }

    @Subscribe("showValueBtn")
    protected fun onShowValueBtnClick(event: Button.ClickEvent?) {
        timePicker!!.callFunction("showValue")
    }
}